SystemOrganization addCategory: #'CS598rej-HW4'!
SystemOrganization addCategory: #'CS598rej-HW4-Test'!

Magnitude subclass: #MilitaryRank
	instanceVariableNames: 'rank'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW4'!

!MilitaryRank commentStamp: 'm3r 6/9/2008 22:36' prior: 0!
MilitaryRank is an abstract class for the Army and Navy rank classes you must create for CS598rej HW4.

Instance variables:
- rank 		- this ivar is available for your use in completing the assignment.
!

!MilitaryRank class methodsFor: 'error handling' stamp: 'm3r 6/9/2008 22:28'!
doesNotUnderstand: aMessage 
	"Optional advanced exercise.
	If you are up to it, you can reimplement this method to assist you in avoiding 
	making individual instance creation methods for each rank name."
	^ super doesNotUnderstand: aMessage 
! !

!MilitaryRank class methodsFor: 'error handling' stamp: 'm3r 6/10/2008 12:18'!
errorUnknownRank: rankNameString
	"Implement this method using the provided error message (on the instance side) as a guide.
	Make use of this error method in the appropriate call site."
	self shouldBeImplemented.
! !

!MilitaryRank class methodsFor: 'testing' stamp: 'm3r 6/10/2008 12:22'!
isValidRankName: rankNameString
	"Answers if the rankNameString is a valid rankName."
	"This method is here for your convenience."
	^ self rankNames includes: rankNameString
! !

!MilitaryRank class methodsFor: 'instance creation' stamp: 'm3r 6/10/2008 12:22'!
named: rankNameString
	"Answers a new military rank of the rank named by the rankNameString."

	"Implement this method in a fashion that its subclasses do not need to implement it."
	self shouldBeImplemented.
! !

!MilitaryRank class methodsFor: 'converting' stamp: 'm3r 6/12/2008 00:14'!
rankNameFromSelector: rankNameSelector ifInvalid: invalidBlock
	"Answers if the rankNameSelector is a valid for creating a rank.
	If not, it executed the invalidBlock."
	"This method is here for your convenience in solving the optional reflection exercise."
	^ self rankNames 
		detect: [:rankName | (self selectorFromRankName: rankName) sameAs: rankNameSelector]
		ifNone: [invalidBlock value]
! !

!MilitaryRank class methodsFor: 'accessing' stamp: 'm3r 6/10/2008 04:02'!
rankNames
	"Answers an array of strings of all of the names of the ranks in ascending order."
	"Do not change this method here.  Instead, implement it in the subclasses."
	self subclassResponsibility.
! !

!MilitaryRank class methodsFor: 'converting' stamp: 'm3r 6/12/2008 00:45'!
selectorFromRankName: rankNameString
	"Converts any rank name into a valid selector."
	| words followingWords selector |
	words := rankNameString substrings.
	followingWords := words allButFirst collect: [:word | word asLowercase capitalized].
	selector := followingWords 
		inject: words first asLowercase
		into: [:composite :word | composite , word].
	^ selector asSymbol
! !

!MilitaryRank methodsFor: 'comparing' stamp: 'm3r 6/10/2008 11:33'!
= aRank
	"Answers whether or not aRank is of equal rank to self.
	A rank can only be compared with another rank from the same military branch."
	
	"Implement this method in a fashion that its subclasses do not need to implement it."
	self shouldBeImplemented.
! !

!MilitaryRank methodsFor: 'private' stamp: 'm3r 6/9/2008 00:24'!
comparisonErrorString
	^ self printString , ' can only be compared with another instance of ' , self class printString
! !

!MilitaryRank methodsFor: 'error handling' stamp: 'm3r 6/11/2008 01:04'!
errorImproperComparison
	self error: self comparisonErrorString! !

!MilitaryRank methodsFor: 'comparing' stamp: 'm3r 6/11/2008 23:05'!
hash
	"Hash must be redefined whenever = is redefined.
	I have done it here for you, so don't change this method.'"
	^ self name hash
! !

!MilitaryRank methodsFor: 'accessing' stamp: 'm3r 6/10/2008 11:33'!
name
	"Answers a string that is the name of the rank."

	"Implement this method in a fashion that its subclasses do not need to implement it."
	self shouldBeImplemented.
! !

TestCase subclass: #MilitaryRankTest
	instanceVariableNames: 'rankSubclasses armyRank navyRank'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW4-Test'!

!MilitaryRankTest commentStamp: 'm3r 6/9/2008 22:37' prior: 0!
The tests for CS598rej HW4.!

!MilitaryRankTest methodsFor: 'private' stamp: 'CharlieMeyer 6/8/2012 01:50'!
hashedArmyRanks
	^ 92566840 .
! !

!MilitaryRankTest methodsFor: 'private' stamp: 'CharlieMeyer 6/8/2012 01:50'!
hashedNavyRanks
	^ 166290798 .
! !

!MilitaryRankTest methodsFor: 'private' stamp: 'm3r 6/10/2008 01:52'!
messageTextFor: rankClass	
	^ rankClass new comparisonErrorString
! !

!MilitaryRankTest methodsFor: 'running' stamp: 'm3r 6/10/2008 02:13'!
setUp
	rankSubclasses := MilitaryRank subclasses.
	armyRank := Smalltalk classNamed: #ArmyRank.
	navyRank := Smalltalk classNamed: #NavyRank.
! !

!MilitaryRankTest methodsFor: 'running' stamp: 'm3r 6/10/2008 02:14'!
tearDown
	rankSubclasses := armyRank := navyRank := nil.
! !

!MilitaryRankTest methodsFor: 'testing' stamp: 'm3r 6/10/2008 03:12'!
testComparing
	self shouldnt: [armyRank private < armyRank private].
	self should: [armyRank general > armyRank private].
	self should: [navyRank seaman <= navyRank captain].
	self shouldnt: [navyRank commander >= navyRank captain].
! !

!MilitaryRankTest methodsFor: 'testing' stamp: 'm3r 6/10/2008 01:59'!
testDeclaredSubclasses
	self should: [rankSubclasses anySatisfy: [:class | class name = #ArmyRank]].
	self should: [rankSubclasses anySatisfy: [:class | class name = #NavyRank]].
! !

!MilitaryRankTest methodsFor: 'testing' stamp: 'm3r 6/10/2008 02:06'!
testEquality
	self assert: (armyRank captain = armyRank captain).
	self assert: (navyRank captain = navyRank captain).
	self deny: (armyRank captain = navyRank captain).
	self deny: (armyRank captain = armyRank general).
	self deny: (3 = armyRank captain).
	self deny: (armyRank captain = 3).
! !

!MilitaryRankTest methodsFor: 'testing' stamp: 'm3r 6/12/2008 00:04'!
testImproperComparing
	self should: [armyRank captain > navyRank captain] raise: Error withExceptionDo: 
		[:exception | self 
			assert: exception messageText = (self messageTextFor: navyRank)
			description: 'Ranks from different military branches cannot be compared!!'].
	self should: [navyRank captain < 3] raise: Error withExceptionDo: 
		[:exception | self 
			assert: exception messageText = (self messageTextFor: navyRank)
			description: 'Ranks cannot be compared with non-rank objects!!'].		
	self should: [3 < navyRank captain] raise: Error description: 
		'Ranks cannot be compared with non-rank objects!!'.
! !

!MilitaryRankTest methodsFor: 'testing' stamp: 'm3r 6/12/2008 00:16'!
testInstantiationViaAllRankNameMethods
	| selector rank |
	rankSubclasses do:
		[:rankClass | rankClass rankNames do: 
			[:rankName | 
			selector := rankClass selectorFromRankName: rankName.
			rank := rankClass perform: selector.
			rank name = rankName]].
! !

!MilitaryRankTest methodsFor: 'testing' stamp: 'm3r 6/10/2008 03:17'!
testName
	| rank |
	rank := armyRank named: 'second lieutenant'.
	self assert: (rank name = 'second lieutenant').
	rank := navyRank named: 'lieutenant'.
	self assert: (rank name = 'lieutenant').
! !

!MilitaryRankTest methodsFor: 'testing for code smells' stamp: 'm3r 6/10/2008 03:35'!
testNoInstanceMethodsAddedToSubclasses
	| implementors |
	implementors := rankSubclasses select: [:each | each selectors size > 0].
	self 
		should: [implementors size = 0]
		description: 'Subclasses of MilitaryRank should not implement any instance methods!!'
! !

!MilitaryRankTest methodsFor: 'testing for code smells' stamp: 'CharlieMeyer 6/10/2012 16:22'!
testOnlyOneExtraComparisonMethodAddedToAbstractClass
	"This is a sneaky way to test the name of extra method without giving it away. ;-)"
	| list |
	list := (MilitaryRank organization listAtCategoryNamed: 'comparing') asOrderedCollection.
	self should: [list size = 3].
	self should: [list includes: #=].
	list remove: #=.
	self should: [list includes: #hash].
	list remove: #hash.
	self should: [list last hash = 197651212].
! !

!MilitaryRankTest methodsFor: 'testing' stamp: 'm3r 6/24/2008 22:24'!
testRankNames
	"This is a sneaky way to test if the rankNames methods are implemented 
	properly without giving awat the answers. ;-)"
	self should: [armyRank rankNames size = 10].
	self should: [armyRank rankNames asArray hash = self hashedArmyRanks].
	self should: [navyRank rankNames size = 8].
	self should: [navyRank rankNames asArray hash = self hashedNavyRanks].
! !

!MilitaryRankTest methodsFor: 'testing' stamp: 'm3r 6/10/2008 10:53'!
testSampleRankNameMethodInstantiation
	| rank |
	rank := armyRank secondLieutenant.
	self assert: rank name = 'second lieutenant'.
	rank := navyRank admiral.
	self assert: rank name = 'admiral'.
! !

!MilitaryRankTest methodsFor: 'testing' stamp: 'm3r 6/12/2008 00:43'!
testSelectorFromRankName
	self should: [(MilitaryRank selectorFromRankName: 'abc') == #abc].
	self should: [(MilitaryRank selectorFromRankName: 'Abc ') == #abc].
	self should: [(MilitaryRank selectorFromRankName: 'aBC') == #abc].
	self should: [(MilitaryRank selectorFromRankName: 'abc') == #abc].
	self should: [(MilitaryRank selectorFromRankName: 'abc de') == #abcDe].
	self should: [(MilitaryRank selectorFromRankName: 'Abc De') == #abcDe].
	self should: [(MilitaryRank selectorFromRankName: 'abc de gh') == #abcDeGh].
	self should: [(MilitaryRank selectorFromRankName: 'Abc De Gh') == #abcDeGh].
! !

!MilitaryRankTest methodsFor: 'testing for code smells' stamp: 'm3r 6/10/2008 02:58'!
testSubclassesImplementClassMethodRankNames
	rankSubclasses do: [:each | self should: [each class includesSelector: #rankNames]].
! !

!MilitaryRankTest methodsFor: 'testing' stamp: 'm3r 6/10/2008 03:59'!
testUnknownInstantiationMethod
	self should: [armyRank maggot] raise: MessageNotUnderstood.
	self should: [navyRank landLubber] raise: MessageNotUnderstood.
! !

!MilitaryRankTest methodsFor: 'testing' stamp: 'm3r 6/10/2008 03:59'!
testUnknownRank
	self should: [armyRank named: 'maggot'] raise: Error.
	self should: [navyRank named: 'land lubber'] raise: Error.
! !
